#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

void ATL_cJIK64x64x64TT0x0x0_aX_b0
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=T, MB=64, NB=64, KB=64, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=8, ku=4, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.3)
 */
{
   const float *stM = A + (((lda) << 7));
   const float *stN = B + 128;
   const float *pfA = A + M;
   const float BetaAlpha = beta / alpha;
   #define incAk 8
   const int incAm = ((((lda) - 64) << 1)), incAn = -(((lda) << 7));
   const int incBk = (((ldb) << 1)), incBm = -(((ldb) << 7));
   #define incBn 16
   #define incCm 2
   const int incCn = (((ldc) << 4)) - 128;
   float *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1)), *pC3=pC2+(((ldc) << 1)), *pC4=pC3+(((ldc) << 1)), *pC5=pC4+(((ldc) << 1)), *pC6=pC5+(((ldc) << 1)), *pC7=pC6+(((ldc) << 1));
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0;
   register float rB0, rB1, rB2, rB3, rB4, rB5, rB6, rB7;
   register float rC0_0, rC0_1, rC0_2, rC0_3, rC0_4, rC0_5, rC0_6, rC0_7;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+16);
      ATL_pfl1R(pfA+32);
      ATL_pfl1R(pfA+48);
      pfA += lda;
      do /* M-loop */
      {
/*
 *       Feeble prefetch of C
 */
         rC0_0 = *pC0;
         rC0_1 = *pC1;
         rC0_2 = *pC2;
         rC0_3 = *pC3;
         rC0_4 = *pC4;
         rC0_5 = *pC5;
         rC0_6 = *pC6;
         rC0_7 = *pC7;
         rC0_0 = rC0_1 = rC0_2 = rC0_3 = rC0_4 = rC0_5 = rC0_6 = rC0_7 = 0.0;
         for (k=64; k; k -= 4) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rB1 = pB0[2];
            rB2 = pB0[4];
            rB3 = pB0[6];
            rB4 = pB0[8];
            rB5 = pB0[10];
            rB6 = pB0[12];
            rC0_0 += rA0 * rB0;
            rB7 = pB0[14];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rC0_6 += rA0 * rB6;
            rC0_7 += rA0 * rB7;
            pB0 += incBk;
            rA0 = pA0[2];
            rB0 = *pB0;
            rB1 = pB0[2];
            rB2 = pB0[4];
            rB3 = pB0[6];
            rB4 = pB0[8];
            rB5 = pB0[10];
            rB6 = pB0[12];
            rC0_0 += rA0 * rB0;
            rB7 = pB0[14];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rC0_6 += rA0 * rB6;
            rC0_7 += rA0 * rB7;
            pB0 += incBk;
            rA0 = pA0[4];
            rB0 = *pB0;
            rB1 = pB0[2];
            rB2 = pB0[4];
            rB3 = pB0[6];
            rB4 = pB0[8];
            rB5 = pB0[10];
            rB6 = pB0[12];
            rC0_0 += rA0 * rB0;
            rB7 = pB0[14];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rC0_6 += rA0 * rB6;
            rC0_7 += rA0 * rB7;
            pB0 += incBk;
            rA0 = pA0[6];
            rB0 = *pB0;
            rB1 = pB0[2];
            rB2 = pB0[4];
            rB3 = pB0[6];
            rB4 = pB0[8];
            rB5 = pB0[10];
            rB6 = pB0[12];
            rC0_0 += rA0 * rB0;
            rB7 = pB0[14];
            rC0_1 += rA0 * rB1;
            rC0_2 += rA0 * rB2;
            rC0_3 += rA0 * rB3;
            rC0_4 += rA0 * rB4;
            rC0_5 += rA0 * rB5;
            rC0_6 += rA0 * rB6;
            rC0_7 += rA0 * rB7;
            pB0 += incBk;
            pA0 += incAk;
         }
         pB0 -= 0*incBk;
         rB0 = alpha;
         rC0_0 *= rB0;
         rC0_1 *= rB0;
         rC0_2 *= rB0;
         rC0_3 *= rB0;
         rC0_4 *= rB0;
         rC0_5 *= rB0;
         rC0_6 *= rB0;
         rC0_7 *= rB0;
         *pC0 = rC0_0;
         *pC1 = rC0_1;
         *pC2 = rC0_2;
         *pC3 = rC0_3;
         *pC4 = rC0_4;
         *pC5 = rC0_5;
         *pC6 = rC0_6;
         *pC7 = rC0_7;
         pC0 += incCm;
         pC1 += incCm;
         pC2 += incCm;
         pC3 += incCm;
         pC4 += incCm;
         pC5 += incCm;
         pC6 += incCm;
         pC7 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pC4 += incCn;
      pC5 += incCn;
      pC6 += incCn;
      pC7 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
